TimerCtrl = ($scope, Work, Break) ->
  T = $scope.timer =
    clock: 0
    name: null
    work: null
    brake: null

  E = $('#timer')

  show = ->
    E.css top: '20%'
    E.modal('show').on 'hidden.bs.modal', ->
      E.css top: -1000
      Work.remove(workId: T.work.id, taskId: T.work.taskId) if T.work
      Break.remove(breakId: T.brake.id) if T.brake

  $scope.hide = ->
    E.modal('hide')
    E.css top: -1000

  $scope.finishBreak = ->
    T.brake.stopUtc = moment.utc().format()
    T.brake.stopZone = moment().zone()
    T.brake.stopLat = $scope.$parent.geo.latitude
    T.brake.stopLng = $scope.$parent.geo.longitude
    T.brake.stopAcc = $scope.$parent.geo.accuracy
    T.brake.$save breakId: T.brake.id, ->
      T.brake = null
      $scope.hide()

  $scope.finishWork = ->
    T.work.stopUtc = moment.utc().format()
    T.work.stopZone = moment().zone()
    T.work.stopLat = $scope.$parent.geo.latitude
    T.work.stopLng = $scope.$parent.geo.longitude
    T.work.stopAcc = $scope.$parent.geo.accuracy
    T.work.$save workId: T.work.id, taskId: T.work.taskId, ->
      $scope.$parent.works.push T.work
      T.work = null
      $scope.hide()

  $scope.$on 'start:work', (event, work) ->
    sec = 60 * $scope.tomato.workMin
    elapsed = moment.utc().diff moment.utc work.startUtc
    T.clock = sec - Math.floor elapsed / 1000
    T.work = work
    T.brake = null
    T.name = (t.name for t in $scope.tasks when t.id is work.taskId)[0]
    show()

  $scope.$on 'start:break', (event, brake) ->
    elapsed = moment.utc().diff moment.utc brake.startUtc
    T.clock = Math.max 1, Math.floor elapsed / 1000
    T.name = brake.name
    T.work = null
    T.brake = brake
    show()

  $scope.hide()

TimerCtrl.$inject = ['$scope', 'Work', 'Break']


TomatoCtrl = ($scope, $timeout, Tomato, Task, Work, Break) ->
  $('.tipped').tooltip placement: 'bottom'

  $scope.tomato = Tomato.get()
  $scope.tasks = Task.query()

  $scope.doAlert = true
  $scope.doSound = true
  $scope.geo = null

  $scope.toggleGeo = ->
    if $scope.geo is null
      $scope.geo = {}
    else
      $scope.geo = null
    if $scope.doGeo isnt null
      navigator.geolocation.getCurrentPosition (geoloc) ->
        $scope.geo = geoloc.coords
        console.log $scope.geo

  $scope.toggleGeo()

  $scope.breaks = Break.query ->
    for brake in $scope.breaks
      continue if brake.stopUtc > brake.startUtc
      $scope.$broadcast 'start:break', brake
      break

  $scope.works = Work.query ->
    earliest = moment.utc().subtract $scope.tomato.workMin, 'minutes'
    for work in $scope.works
      continue unless work.stopUtc < work.startUtc
      cr = moment.utc work.startUtc
      if cr < earliest
        work.$remove(workId: work.id, taskId: work.taskId)
      else
        $scope.$broadcast 'start:work', work
        break

  $scope.ui =
    filter: ''
    order: (t) ->
      finish = if t.finishUtc > t.createUtc then '1' else '0'
      "#{finish}:#{9-t.priority}:#{t.createUtc}"
    edit: false
    task: new Task(name: '', priority: 0, difficulty: 0)
    brake: new Break(name: 'quick')

  $scope.edit = ->
    $scope.ui.edit = not $scope.ui.edit
    $timeout($('#slug').select, 100) if $scope.ui.edit

  $scope.update = ->
    Tomato.save $scope.tomato, (t) ->
      [_, p, _, s] = window.location.href.match /^(.+?)\/([^\/]+)\/(\#.+)$/
      url = "#{p}/#{encodeURIComponent $scope.tomato.slug}/"
      window.location.href = if s then "#{url}#{s}" else url
      $scope.ui.edit = false

  $scope.remove = ->
    Tomato.remove $scope.tomato, (t) ->
      [_, p, _, _] = window.location.href.match /^(.+?)\/([^\/]+)\/(\#.+)$/
      window.location.href = p

  $scope.addTask = ->
    return if $scope.ui.task.name is ''
    Task.save $scope.ui.task, (task) ->
      $scope.tasks.push task
      $scope.ui.task = new Task name: '', priority: 0, difficulty: 0
      $timeout $('#cr').select, 100

  $scope.startBreak = ->
    $scope.ui.brake.startUtc = moment.utc().format()
    $scope.ui.brake.startZone = moment().zone()
    $scope.ui.brake.startLat = $scope.geo.latitude
    $scope.ui.brake.startLng = $scope.geo.longitude
    $scope.ui.brake.startAcc = $scope.geo.accuracy
    Break.save $scope.ui.brake, (brake) ->
      $scope.ui.brake = new Break name: 'quick'
      $scope.$broadcast 'start:break', brake

  $('#cr').select()

TomatoCtrl.$inject = ['$scope', '$timeout', 'Tomato', 'Task', 'Work', 'Break']


TaskCtrl = ($scope, Work) ->
  task = $scope.$parent.task

  $scope.works = ->
    (w for w in $scope.$parent.works when w.taskId is task.id)

  $scope.flag = ->
    return if task.finishUtc > task.createUtc
    task.priority = if task.priority is 0 then 1 else 0
    task.$save taskId: task.id

  $scope.start = ->
    return if task.finishUtc > task.createUtc
    w = new Work
      startUtc: moment.utc().format()
      startZone: moment().zone()
      startLat: $scope.$parent.geo.latitude
      startLng: $scope.$parent.geo.longitude
      startAcc: $scope.$parent.geo.accuracy
    w.$save taskId: task.id, (w) ->
      $scope.$parent.$parent.$broadcast 'start:work', w

  $scope.remove = ->
    return if task.finishUtc > task.createUtc
    task.$remove taskId: task.id

  $scope.finish = ->
    if task.finishUtc is null or task.finishUtc <= task.createUtc
      task.finishUtc = moment.utc()
    else
      task.finishUtc = moment.utc(0)
    task.$save taskId: task.id

TaskCtrl.$inject = ['$scope', 'Work']


angular.module('app.controllers', ['app.services'])
  .controller('TomatoCtrl', TomatoCtrl)
  .controller('TaskCtrl', TaskCtrl)
  .controller('TimerCtrl', TimerCtrl)
